<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/ClassTree.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/ClassTree.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/ClassTree.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-string">&quot;&quot;&quot;Contains the utility class ClassTree, for creating inheritance trees.&quot;&quot;&quot;</span></span>
<a id="line10"></a><span class="lineno"> 10</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line12"></a><span class="lineno"> 12</span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html">ClassTree</a>(ASG.Visitor):</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Maintains a tree of classes directed by inheritance. This object always</span></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line"><span class="py-string">    exists in HTML, since it is used for other things such as printing class bases.&quot;&quot;&quot;</span></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">    <span class="py-comment"># TODO - only create if needed (if Info tells us to)</span></span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#__init__">__init__</a>(self):</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">        self.__superclasses = {}</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">        self.__subclasses = {}</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">        self.__classes = []</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">        <span class="py-comment"># Graph stuffs:</span></span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">        self.__buckets = [] <span class="py-comment"># List of buckets, each a list of classnames</span></span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#add_inheritance">add_inheritance</a>(self, supername, subname):</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Adds an edge to the graph. Supername and subname are the scoped</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="py-string">        names of the two classes involved in the edge, and are copied before</span></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="py-string">        being stored.&quot;&quot;&quot;</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">        self.add_class(supername)</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.__subclasses.has_key(supername):</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">            subs = self.__subclasses[supername] = []</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">            subs = self.__subclasses[supername]</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">        <span class="py-keyword">if</span> subname <span class="py-keyword">not</span> <span class="py-keyword">in</span> subs:</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">            subs.append(subname)</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">            subs.sort()</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.__superclasses.has_key(subname):</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">            sups = self.__superclasses[subname] = []</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">            sups = self.__superclasses[subname]</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        <span class="py-keyword">if</span> supername <span class="py-keyword">not</span> <span class="py-keyword">in</span> sups:</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">            sups.append(supername)</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">            sups.sort()</span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#subclasses">subclasses</a>(self, classname):</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a sorted list of all classes derived from the given</span></span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line"><span class="py-string">        class&quot;&quot;&quot;</span></span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">        <span class="py-keyword">if</span> self.__subclasses.has_key(classname):</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">            <span class="py-keyword">return</span> self.__subclasses[classname]</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">            <span class="py-keyword">return</span> []</span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#superclasses">superclasses</a>(self, classname):</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a sorted list of all classes the given class derives</span></span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line"><span class="py-string">        from. The classes are returned as scoped names, which you may use to</span></span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="py-string">        lookup the class declarations in the 'types' dictionary if you need</span></span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line"><span class="py-string">        to.&quot;&quot;&quot;</span></span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        <span class="py-keyword">if</span> self.__superclasses.has_key(classname):</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">            <span class="py-keyword">return</span> self.__superclasses[classname]</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">            <span class="py-keyword">return</span> []</span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#classes">classes</a>(self):</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a sorted list of all class names&quot;&quot;&quot;</span></span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        <span class="py-keyword">return</span> self.__classes</span>
<a id="line70"></a><span class="lineno"> 70</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#add_class">add_class</a>(self, name):</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Adds a class to the list of classes by name&quot;&quot;&quot;</span></span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">        <span class="py-keyword">if</span> name <span class="py-keyword">not</span> <span class="py-keyword">in</span> self.__classes:</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">            self.__classes.append(name)</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">            self.__classes.sort()</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#roots">roots</a>(self):</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a list of classes that have no superclasses&quot;&quot;&quot;</span></span>
<a id="line80"></a><span class="lineno"> 80</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">        <span class="py-keyword">return</span> [c <span class="py-keyword">for</span> c <span class="py-keyword">in</span> self.classes() <span class="py-keyword">if</span> c <span class="py-keyword">not</span> <span class="py-keyword">in</span> self.__superclasses]</span>
<a id="line82"></a><span class="lineno"> 82</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">    <span class="py-comment">#</span></span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">    <span class="py-comment"># Graph methods</span></span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">    <span class="py-comment">#</span></span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#graphs">graphs</a>(self):</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a list of graphs. Each graph is just a list of connected</span></span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line"><span class="py-string">        classes.&quot;&quot;&quot;</span></span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">        self._make_graphs()</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        <span class="py-keyword">return</span> self.__buckets</span>
<a id="line92"></a><span class="lineno"> 92</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#leaves">leaves</a>(self, graph):</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns a list of leaves in the given graph. A leaf is a class with</span></span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line"><span class="py-string">        no subclasses&quot;&quot;&quot;</span></span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">        <span class="py-keyword">return</span> [c <span class="py-keyword">for</span> c <span class="py-keyword">in</span> graph <span class="py-keyword">if</span> c <span class="py-keyword">not</span> <span class="py-keyword">in</span> self.__subclasses]</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#_make_graphs">_make_graphs</a>(self):</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">        processed = {}</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">        <span class="py-keyword">for</span> root <span class="py-keyword">in</span> self.roots():</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">            <span class="py-keyword">if</span> root <span class="py-keyword">in</span> processed:</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">                <span class="py-keyword">continue</span></span>
<a id="line105"></a><span class="lineno">105</span><span class="line">            bucket = []</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">            self.__buckets.append(bucket)</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">            classes = [root]</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">            <span class="py-keyword">while</span> len(classes):</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">                name = classes.pop()</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">                <span class="py-keyword">if</span> name <span class="py-keyword">in</span> processed:</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">                    <span class="py-keyword">continue</span></span>
<a id="line112"></a><span class="lineno">112</span><span class="line">                <span class="py-comment"># Add to bucket</span></span>
<a id="line113"></a><span class="lineno">113</span><span class="line">                bucket.append(name)</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">                processed[name] = True</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">                <span class="py-comment"># Add super- and sub-classes</span></span>
<a id="line116"></a><span class="lineno">116</span><span class="line">                classes.extend(self.superclasses(name))</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">                classes.extend(self.subclasses(name))</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">    <span class="py-comment">#</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line">    <span class="py-comment"># ASG Visitor</span></span>
<a id="line120"></a><span class="lineno">120</span><span class="line">    <span class="py-comment">#</span></span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#visit_scope">visit_scope</a>(self, scope):</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> scope.declarations:</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">            d.accept(self)</span>
<a id="line125"></a><span class="lineno">125</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/ClassTree/ClassTree.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Adds this class and all edges to the lists&quot;&quot;&quot;</span></span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">        self.add_class(class_.name)</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">        <span class="py-keyword">for</span> inheritance <span class="py-keyword">in</span> class_.parents:</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">            parent = inheritance.parent</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">            <span class="py-keyword">if</span> hasattr(parent, <span class="py-string">'declaration'</span>):</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">                self.add_inheritance(parent.declaration.name, class_.name)</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">            <span class="py-keyword">elif</span> isinstance(parent, ASG.ParametrizedTypeId) <span class="py-keyword">and</span> parent.template:</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">                self.add_inheritance(parent.template.name, class_.name)</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">            <span class="py-keyword">elif</span> isinstance(parent, ASG.UnknownTypeId):</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">                self.add_inheritance(parent.link, class_.name)</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">        <span class="py-keyword">for</span> d <span class="py-keyword">in</span> class_.declarations:</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">            d.accept(self)</span>
<a id="line140"></a><span class="lineno">140</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:13 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
